/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef HISTPLOT_H
#define HISTPLOT_H

#include <QWidget>

#include "HistPlotBase.h"
#include "dsplib/th1.h"

class HistPlot : public HistPlotBase
{
    Q_OBJECT
public:
    explicit HistPlot(QWidget *parent = nullptr);

signals:

public Q_SLOTS:
    void setHist(const th1 &r);

private:
    th1 h;
    std::vector<double> px, fpx, py, fpy;
    double value = 0;
    double mean = 0;
    double sigma = 0;
    double norm = 0;
    bool fit_ok = false;
    int modseq = 0;
};

#endif // HISTPLOT_H
