//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef RUNCONTROLWIDGET_H
#define RUNCONTROLWIDGET_H

#include "ui_RunControlWidgetUi.h"
#include "adcmlib/daqtypes.h"

class RunControlWidget : public QWidget, public Ui::RunControlWidgetUi
{
    Q_OBJECT
public:
    explicit RunControlWidget(QWidget *parent = nullptr);
    void updateGui();
    void enablePowerOff(bool);

protected:
    void updateStatusLabel();
    void updateButtons();

signals:
    void powerOff();
    void changeStateRequest(daq_state_t);

public slots:
    void setState( daq_state_t );
    void on_pbPower_clicked();
    void on_pbReset_clicked();
    void on_pbRun_clicked();
    void on_pbPause_clicked();

private:
    daq_state_t state;
};

#endif // RUNCONTROLWIDGET_H
