/*
**    Copyright 2010-2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CALZERODIALOG_H
#define CALZERODIALOG_H

#include "ui_calzerodialogbase.h"
#include "calibrationdialog.h"

class QAbstractTableModel;

class CalZeroDialog : public CalibrationDialog, public Ui::CalZeroDialogBase
{
    Q_OBJECT
public:
    explicit CalZeroDialog(QWidget * parent = nullptr);

Q_SIGNALS:
    void calZeroConfigChanged(const CalZeroConfig &);

protected Q_SLOTS:
    void update() override;
    virtual void exportAction();
    void buttonBox_clicked(QAbstractButton* button);
    void clearEnabled();

private:
    bool enabled_ch_has_calzero() const;

    QAbstractTableModel *d_model;
};

#endif // CALZERODIALOG_H
