//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef FITTERSETTINGSDIALOG_H
#define FITTERSETTINGSDIALOG_H

#include "ui_fittersettingsdialogbase.h"

class FitterSettingsDialogPrivate;
class FitProfile;

class FitterSettingsDialog : public QDialog, public Ui::FitterSettingsDialogBase
{
    Q_OBJECT
public:
    explicit FitterSettingsDialog(QWidget * parent = nullptr);
    ~FitterSettingsDialog() override = default;
//    FitProfile getData() const;
    void Restore();
    void RestoreDetails();
    void setbuttons();
    bool custom_profile() const;
    void accept() override;

Q_SIGNALS:
    void modified(const FitProfile &);

public Q_SLOTS:
    void setData(const FitProfile &data);

protected:
    void setFitAlgorithm( int v );
    void apply();
    void restoreDefaults();
    void update_sb_np();

//    FitterSettingsDialog(FitterSettingsDialogPrivate &&d, QWidget * parent, const AdcConfig &adcConfig, const DecoderConfig &decoderConfig);
    FitterSettingsDialogPrivate * const d_ptr;

private:
    Q_DECLARE_PRIVATE(FitterSettingsDialog)
    bool restoring = false;

private Q_SLOTS:
    void on_buttonBox_clicked(QAbstractButton* button);
    void on_rb_slow_clicked();
    void on_rb_fast_clicked();
    void on_sb_ni_valueChanged( int v );
    void on_sb_np_valueChanged( int v );
    void on_cb_fit_a_toggled( bool st );
    void on_cb_fit_w_toggled( bool st );
    void on_comboBox_prof_activated( int );
};

#endif // FITTERSETTINGSDIALOG_H
