
#include <qwt_math.h>
#include <qwt_symbol.h>

#include "plot.h"

Plot::Plot(QWidget *p) :QwtPlot(p)
{
    setup_contents();
}

void Plot::setup_contents()
{
    /*
    // Assign a title
//    setTitle("ADC waveform");
    setAutoLegend(FALSE);

    //  Insert zero line at y = 0
//    long mY = insertLineMarker("", QwtPlot::yLeft);     
//    setMarkerYPos(mY, 0.0);

    // Set axis titles
//    setAxisTitle(QwtPlot::xBottom, "Time/seconds");
//    setAxisTitle(QwtPlot::yLeft, "Values");

//    setAxisOptions(QwtPlot::yLeft, QwtAutoScale::Floating | QwtAutoScale::Logarithmic);
*/  
}

void Plot::setpoints(int id, const std::vector<double> &inx, const std::vector<double> &iny)
{
    if (!curves[id]) return;
#if QWT_VERSION >= 0x060000
    curves[id]->setSamples(&inx[0], &iny[0], std::min(inx.size(), iny.size())); // qwt 6
#else
    curves[id]->setData(&inx[0], &iny[0], std::min(inx.size(), iny.size())); // qwt 5
#endif
}

void Plot::addcurve(int id, const char *title)
{
    QwtPlotCurvePtr crv(new QwtPlotCurve(title));
    //  my_curve_t crv = new QwtPlotCurve(this, title);
    curves[id] = crv;
    crv->attach(this);
//    crv->setSymbol(QwtSymbol(QwtSymbol::XCross, QBrush(Qt::black), QPen(Qt::black), QSize(2,2))); // qwt 5
// TODO: qwt 6
    QPen pen = QPen(Qt::black);
    if ((id%2) == 0) pen=QPen(Qt::blue);
    else pen=QPen(Qt::red);
    crv->setPen(pen);
}

void Plot::setxrange(double xmin, double xmax) {
    setAxisScale(QwtPlot::xBottom, xmin, xmax, 0);
}

void Plot::setcolor(int id, const QColor &color)
{
    if (!curves[id]) return;
    curves[id]->setPen (QPen(color));
}
