#ifndef _PLOT1_H
#define _PLOT1_H

#include <QMap>
#include <vector>

#include <qwt_plot.h>
#include <qwt_plot_curve.h>
#include <QSharedPointer>

class QColor;

class Plot : public QwtPlot
{
public:
    explicit Plot(QWidget *p = nullptr);
    virtual void setpoints (int id, const std::vector<double> &inx, const std::vector<double> &iny);
    void addcurve(int id, const char *title);
    void setxrange(double xmin, double xmax);
    void setcolor(int id, const QColor &color);

protected:
    void setup_contents();

private:
    typedef QSharedPointer<QwtPlotCurve> QwtPlotCurvePtr;
    typedef QMap< int, QwtPlotCurvePtr > QwtPlotCurveMap;

    QwtPlotCurveMap curves;
};

#endif /* _PLOT1_H */
