
#include <QWidget>
#include <QCursor>
#include <QApplication>
#include <QTimer>

#include "qutil.h"

localWaitCursor::localWaitCursor(QWidget *w)
{
    widget=w;
    if (widget) {
	save_cursor = widget->cursor();
	widget->setCursor(Qt::WaitCursor);
    }
}

localWaitCursor::~localWaitCursor()
{
    if (widget)
        widget->setCursor(save_cursor);
}


globalWaitCursor::globalWaitCursor()
{
    QApplication::setOverrideCursor(Qt::WaitCursor);
}

globalWaitCursor::~globalWaitCursor()
{
    QApplication::restoreOverrideCursor();
}

ScopedWidgetDisabler::ScopedWidgetDisabler(QWidget *p)
{
    widget = p;
    saveState = widget->isEnabled();
    widget->setEnabled(false);
}
ScopedWidgetDisabler::~ScopedWidgetDisabler()
{
    widget->setEnabled(saveState);
}
/*
TimerStarterOnDestruct::TimerStarterOnDestruct(QTimer *timer, int msec, bool sshot)
    : p_timer(timer), p_msec(msec), p_sshot(sshot)
{
}

TimerStarterOnDestruct::~TimerStarterOnDestruct()
{
    p_timer->start(p_msec, p_sshot);
}
*/
