
#include "RawDataWriter.h"

#include <QDir>
#include <QDebug>

#include "adcmdevice/FrameList.h"
#include "storage.h"

#define PREFIX "RawDataWriter: "
#define WRITER_DEBUG_LEVEL 1
#define WDL WRITER_DEBUG_LEVEL

RawDataWriter::RawDataWriter(QObject *parent)
    : QObject(parent),
      stor(new storage(this))
{
}

void RawDataWriter::reset()
{
    stor->reset ();
}

void RawDataWriter::endBurst()
{
    stor->flush ();
}

void RawDataWriter::writeFrameList(const FrameList &list)
{
    if (list.shouldDrop()) {
        qWarning() << QString("RawDataWriter dropped %1 frames").arg(list.size());
        return;
    }
    for (const QByteArray &buf : list)
        stor->write(buf.constData(), buf.size());
}

void RawDataWriter::setStorageConfig(const StorageConfig &r)
{
    storageConfig = r;
    stor->setFileName(storageConfig.fileName);
    stor->setopt(storageConfig.enable, storageConfig.mode);
    stor->reset();
}
