#ifndef _STORAGE_H
#define _STORAGE_H

#include <QString>
#include <QFile>
#include <QMutex>
//class QMutex;

class storage : public QObject
{
public:
    enum {MODE_RECYCLE=0, MODE_CONT=1};
    explicit storage(QObject *parent = 0);
    virtual ~storage();
    static QString DEFAULT_STORAGE_FILENAME();
    static QString DEFAULT_STORAGE_FILENAME_TMP();

    QString mode_str(int mode) const;
    void print(const char *prefix) const;
    int setopt (bool fenable, int fmode);
    void setFileName (const QString &fn);
    bool reset();
    bool flush();
    bool write(const void *buf, quint64 count);
    void close();
    void lock();
    void unlock();

private:
    QMutex fileMutex;
    bool prepare_files();
    bool enable_storage;
    quint64 storage_nwr, storage_total; // use explicitly 64-bit type
    int mode;
    QFile dataFile;
    QString STORAGE_FILENAME;
    QString STORAGE_FILENAME_TMP;
};

#endif /* _STORAGE_H */
