//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "adchwcounters.h"

void AdcHwCounters::clear()
{
    *this = AdcHwCounters();
}

bool AdcHwCounters::isEmpty() const
{
    return hits.isEmpty();
}

AdcHwCounters &AdcHwCounters::operator-=(const AdcHwCounters &rhs)
{
    const int n = std::min(hits.size(), rhs.hits.size());
    if (startrun_ts > rhs.startrun_ts) {
        if(rhs.startrun_ts)
            startrun_ts = rhs.startrun_ts;
        current_ts = current_ts - startrun_ts;
        // hits are reset by hardware at start_run moment
    } else {
        current_ts -= rhs.current_ts;
        for (int i=0; i<n; i++)
            hits[i] -= rhs.hits[i];
    }
    return *this;
}

const AdcHwCounters AdcHwCounters::operator-(const AdcHwCounters &rhs) const
{
    return AdcHwCounters(*this) -= rhs;
}
