//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef ADCHWCOUNTERS_H
#define ADCHWCOUNTERS_H

#include <QVector>

class AdcHwCounters {
public:
    void clear();
    bool isEmpty() const;
    AdcHwCounters &operator-=(const AdcHwCounters &rhs);
    const AdcHwCounters operator-(const AdcHwCounters &rhs) const;
    double startrun_ts = 0;
    double current_ts = 0;
    quint32 freeTime = 0;
    quint32 busyTime = 0;
    QVector<qint64> hits;
};


#endif // ADCHWCOUNTERS_H
