/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "conf_runtime.h"

conf_runtime_t::conf_runtime_t(size_t numberOfChannels)
{
    runmode = ADCM_RUNMODE_RUN;
    run_enable = false;
    trigbits.all = 0;
    timestamp_is_utc = 1;
    ch_ctrl.resize(numberOfChannels);
//    testpass.all = 0;
//    testfail.all = 0;
}

void conf_runtime_t::clear()
{
    runmode = ADCM_RUNMODE_RUN;
    run_enable = false;
    trigbits.all = 0;
    for(int i=0; i<ch_ctrl.size(); i++)
        ch_ctrl[i].all = 0;
//    testpass.all = 0;
//    testfail.all = 0;
}
