#ifndef _ADCM_EL_H
#define _ADCM_EL_H 1

#include <QVector>
#include <QPair>
#include <QMetaType>
class AdcmEventListPrivate;
class AdcmEvent;
class QSemaphore;

typedef QVector<QPair<uint,AdcmEvent*> >::Iterator EventListIt;
Q_DECLARE_METATYPE( EventListIt )

class adcm_el_t
{
public:
    adcm_el_t(QSemaphore *const freeEvents, QSemaphore *const managerEvents, uint size);
    ~adcm_el_t();

    void reset();

    AdcmEvent *getEvent (unsigned int eventNumber); //! Get event by event number
    void flushManEvents();
    EventListIt next(EventListIt &pairIt, uint shift = 1);
    uint getManagerEvNum();
    EventListIt getStartWorkerPos();
    void setStartWorkerPos(EventListIt pos);
    EventListIt getEndWorkerPos();
    void setEndWorkerPos(EventListIt pos);
    uint getBeginEvNum();
    quint64 getEventsProceed();

private:
    adcm_el_t(const adcm_el_t &); // copy prohibited
    AdcmEventListPrivate * const d;
};

#endif /* _ADCM_EL_H */
