
#include <cstdio> // FIXME

#include <QDebug>
#include <QString>

#include "adcm_ev.h"
#include "AdcmChbuf.h"
#include "adcm16.h"

enum {ADCM_EV_MAX_CH = ADCM_N_CH};

void AdcmEvent::clear()
{
    *this = AdcmEvent();
//    burstNum = 0;
//    evNum = 0;
//    flags = 0;
//    ts = 0;
//    // optimize
//    for (auto c : channel.keys()) {
//        channel[c].clear();
//    }
}

/*
struct adcm_chstat_t *adcm_alloc_chstat()
{
  struct adcm_chstat_t *p = malloc(sizeof(struct adcm_chstat_t));
  adcm_clear_chstat(p);
  return p;
}

void adcm_free_chstat(struct adcm_chstat_t *cs)
{
  if (cs) free(cs);
}

void adcm_clear_chstat(struct adcm_chstat_t *cs)
{
  memset(cs, 0, sizeof(struct adcm_chstat_t));
}

void adcm_add_chstat(struct adcm_chstat_t *cs, const struct adcm_ev_t *ev)
{
  int c;
  if (!cs || !ev) return;

  for(c=0;c<ADCM_N_CH;c++) {
        const adcm_chbuf_t *evc = &ev->ch[c];
        int f = evc->flags;
        if (! f & ADCM_CH_HAS_DATA) continue;
        cs->all[c]++;
        if (f & ADCM_CH_BL_NODATA) cs->blnd[c]++;
        if (f & ADCM_CH_INT_NODATA) cs->intnd[c]++;
        if (f & ADCM_CH_BL_OUT) cs->blout[c]++;
        if (f & ADCM_CH_EVAL_CLIP) cs->clip[c]++;
        if (f & ADCM_CH_EVAL_PU) cs->pu[c]++;
  }
}

void adcm_print_chstat(const struct adcm_chstat_t *cs)
{
  if (!cs) {printf("adcm_print_chstat: (null)"); return;}
}
*/

#if 0
//! create new chbuf in event and return its pointer
adcm_chbuf_t *AdcmEvent::new_ev_chbuf(unsigned int c)
{
    Q_ASSERT(c < ADCM_N_CH);
    if (c >= ADCM_N_CH) return nullptr;

    const short cbufIndex = chIndexes[c]; // chbuf index for channel c: 0..(ev->ncb-1)
    if ((cbufIndex < numChBuf) && (cbufIndex >= 0) && (cbufIndex < ADCM_EV_MAX_CH)) {
        //    printf("ev %d, ch %d: returned existing chbuf at %d\n", ev->ec, c, bn);
        return &chBuf[cbufIndex]; // already exists
    }

    if (numChBuf >= ADCM_EV_MAX_CH) {
        qWarning() << QString("ev %1, ch %2: no more chbuf available").arg(getEventNumber()).arg(c);
        return nullptr; // overflow
    }
    chIndexes[c] = numChBuf;
    const short newCbufIndex = chIndexes[c];
    adcm_chbuf_t *cbuf = &chBuf[newCbufIndex];
    cbuf->clear();
    cbuf->ch = c;
    //  ev->cb[bn].flags=0;
    //  ev->cb[bn].len=0;
    //  printf("ev %d, ch %d: allocated new chbuf at %d\n", ev->ec, c, bn);
    numChBuf++;
    return cbuf; // already exists
    /*
  if (ev && c>=0 && c<ADCM_N_CH)
    return &ev->ch[c];
  else
    return 0;
*/
}

adcm_chbuf_t *AdcmEvent::get_ev_chbuf(unsigned int c)
{
    Q_ASSERT(numChBuf <= ADCM_EV_MAX_CH);
    Q_ASSERT(c < ADCM_N_CH);

    const short cbufIndex = chIndexes[c];
    if (cbufIndex == -1) // not allocated
        return nullptr;
    //TODO
    if(cbufIndex >= numChBuf){
        qWarning()<<QString("Bad channel: cbufIndex=%1; numChBuf=%2; evNum=%3").arg(cbufIndex).arg(numChBuf).arg(evNum&0xffffffff);
    } else
    Q_ASSERT(cbufIndex < numChBuf); // range check
    if ((cbufIndex < numChBuf) && (cbufIndex >= 0 && cbufIndex < ADCM_EV_MAX_CH))
        return &chBuf[cbufIndex]; // already exists
    else
        return nullptr;
}

const adcm_chbuf_t *AdcmEvent::get_ev_chbuf_const(unsigned int c) const
{
    Q_ASSERT(numChBuf <= ADCM_EV_MAX_CH);
    Q_ASSERT(c < ADCM_N_CH);
    if (c >= ADCM_N_CH) return nullptr;

    const short chBufIndex = chIndexes[c];
    if ((chBufIndex < numChBuf) && (chBufIndex >= 0) && (chBufIndex < ADCM_EV_MAX_CH))
        return &chBuf[chBufIndex]; // already exists
    else
        return nullptr;
    //  return &ev->ch[c];
}
#endif

/*
int adcm_write_event (const struct adcm_ev_t * ev)
{

  if (!ev)
    return (-EINVAL);

  FILE *fp = fopen ("test.txt", "a+");
  if (!fp)
    return (-errno);

  fprintf (fp, "#EV: burst %04X, event %04X, ts %16llX\n", ev->bc, ev->ec, ev->ts);
  for (int c = 0; c < ADCM_N_CH; c++) {
        const adcm_chbuf_t *cb = adcm_get_ev_chbuf_const(ev, c);
        if (!cb) continue;
    unsigned int len = cb.len;
    quint64 ts = cb.ts;

    if (len <= 0)
      continue;
    fprintf (fp, "# CH %2d, timestamp: %16llX\n", c, ts);
    for (size_t s = 0; s < cb.len; s++)
      fprintf (fp, "   %3zu\t%d\n", s, cb.w[s] - (1<<(cb.w_bits-1)));
  }
  fclose (fp);
  return (0);
}
*/

void AdcmEvent::print_flags () const
{
    const unsigned int ef = getFlags();
    //  if (!(ef & ADCM_EV_INIT)) {
    //    printf ("event %u not initialized\n", ev->ec);
    //    return;
    //  }
    printf ("event %u, err(%s%s%s%s%s%s%s%s%s%s%s)\n", getEventNumber(),
            (ef & ADCM_EV_INVAL) ? "INVAL " : "",
            (ef & ADCM_EV_ECH) ? "CH" : "",
            (ef & ADCM_EV_EDLEN) ? "LEN" : "",
            (ef & ADCM_EV_EDUPCH) ? "DUP" : "",
            (ef & ADCM_EV_EID) ? "ID" : "",
            (ef & ADCM_EV_ENS) ? "NS" : "",
            (ef & ADCM_EV_EROLL) ? "ROLL" : "",
            (ef & ADCM_EV_ESPW) ? "SPW" : "",
            (ef & ADCM_EV_EBIT) ? "BIT" : "", (ef & ADCM_EV_EUNEXP) ? "UNEXP" : "", (ef & ADCM_EV_BADBLK) ? "BADBLK" : "");
}

void AdcmEvent::print_event () const
{
    QString str;
    QTextStream stream(&str);
    stream << *this;
    qInfo() << str;
}

//void adcm_ev_ch_flag_set(AdcmEvent *ev, unsigned int ch, unsigned int mask, unsigned int value)
//{
//    adcm_chbuf_t &cb = ev->channel[ch];
//    cb.flags = (cb.flags & ~mask) | value;
//}

//int adcm_ev_ch_flag_cmp(const AdcmEvent &ev, unsigned int ch, unsigned int mask, unsigned int value)
//{
//    const adcm_chbuf_t &cb = ev.channel[ch];
//    return (cb.flags & mask) == value;
//}

//int adcm_ev_ch_flag_getbit(const AdcmEvent &ev, unsigned int ch, unsigned int mask)
//{
//    const adcm_chbuf_t &cb = ev.channel[ch];
//    return (cb.flags & mask) != 0;
//}
//void adcm_ev_ch_flag_setbit(AdcmEvent *ev, unsigned int ch, unsigned int mask)
//{
//    adcm_chbuf_t &cb = ev->channel[ch];
//    cb.flags |= mask;
//}
//void adcm_ev_ch_flag_clrbit(AdcmEvent *ev, unsigned int ch, unsigned int mask)
//{
//    adcm_chbuf_t &cb = ev->channel[ch];
//    cb.flags &= ~mask;
//}
