#include "stopwatchtimer.h"

StopWatchTimer::StopWatchTimer(QObject *parent) :
    QObject(parent)
{
    reset();
}

void StopWatchTimer::reset()
{
    runTimeSave = 0;
    lastrunduration = 0;
    isRunning = false;
}

void StopWatchTimer::restart()
{
    reset();
    start();
}

void StopWatchTimer::start()
{
    if (isRunning)
        return;
    tv_rundma = QDateTime::currentDateTime();
    isRunning = true;
}

void StopWatchTimer::stop()
{
    if (!isRunning)
        return;
    isRunning = false;
    QDateTime tv_stopdma = QDateTime::currentDateTime();
    lastrunduration = tv_stopdma.toTime_t() - tv_rundma.toTime_t();
    runTimeSave += lastrunduration;
}

double StopWatchTimer::elapsed() const
{
    if (isRunning) {
        QDateTime tv = QDateTime::currentDateTime();
        return runTimeSave + (tv.toTime_t() - tv_rundma.toTime_t());
    } else
        return runTimeSave;
}
