/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ADC_HARDWARE_TYPES_H
#define ADC_HARDWARE_TYPES_H

#include <cstdint>

typedef union {
    uint16_t all;
    struct {
        unsigned int invert : 1;
        unsigned int hyst : 1;
        unsigned int trig_mult : 1;
        unsigned int sample_len : 1;
        unsigned int ext_rwind : 1;
        unsigned int framer_logic : 1; // ignored
        unsigned int unused  : 8;
        unsigned int fixed  : 2; // constant 01
    } __attribute__ ((packed)) bit;
} adcm_prop_reg_t;

#endif // ADC_HARDWARE_TYPES_H
