//
//    Copyright 2013 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef ADCM_IDS_H
#define ADCM_IDS_H

#include <QtGlobal>
class QString;

enum AdcmId {
    UNKNOWN_BOARD_ID = 0,
    ADCM_BOARD_ID = 0xb4,
    ADCMG_BOARD_ID = 0xb3,
    ADCMLTC_BOARD_ID = 0xb5,
    ADCM3_BOARD_ID = 0xb6,
    BPM4100_BOARD_ID = 0xb7,
    ADC64_BOARD_ID = 0xba,
    ADC64S2_BOARD_ID = 0xc5,
    ADC64S2V4_BOARD_ID = 0xc8,
    ADC64VE_BOARD_ID = 0xd4,
    TQDC16VS_BOARD_ID = 0xd6,
    ADC64ECAL_BOARD_ID = 0xde,
    ADC64VEV2_BOARD_ID = 0xdf
};

QString adc_board_name_str(AdcmId id);
int maxSlaveCount(AdcmId id);
bool isDeviceTypeSupported(AdcmId id);
int boardChannelCount(AdcmId id);
int boardAdcBits(AdcmId id);
double boardAdcStepNs(AdcmId id);
bool boardVirtualSlave(AdcmId id);

#endif // ADCM_IDS_H
