/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "ConfigStatus.h"

ConfigStatus::operator bool() const
{
    return errors.isEmpty();
}

ConfigStatus & ConfigStatus::operator&=(const ConfigStatus &rhs)
{
    if (!rhs.errors.isEmpty()) {
        for (auto &i : rhs.errors)
            errors << title + "/" + i;
    }
    return *this;
}

ConfigStatus &ConfigStatus::operator<<(const QString &str)
{
    errors << (title + ": " + str);
    return *this;
}

QStringList ConfigStatus::errorText() const
{
    QStringList list;
    for (auto &i : errors)
        list << i;
    return list;
}
