/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef CONFIGSTATUS_H
#define CONFIGSTATUS_H

#include <QStringList>

class ConfigStatus
{
public:
    ConfigStatus(const QString &_title, const QStringList &list = QStringList())
        : title(_title), errors(list) {}
    operator bool() const;
    ConfigStatus & operator+=(const ConfigStatus &rhs) = delete;
    ConfigStatus & operator-=(const ConfigStatus &rhs) = delete;
    ConfigStatus & operator|=(const ConfigStatus &rhs) = delete;
    ConfigStatus & operator&=(const ConfigStatus &rhs);
    ConfigStatus & operator<<(const QString &str);

    QStringList errorText() const;

    friend ConfigStatus operator&(ConfigStatus lhs, const ConfigStatus &rhs)
    {lhs &= rhs; return lhs;}

    QString title;
    QStringList errors;
};

#endif // CONFIGSTATUS_H
