//
//    Copyright 2013-2019 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef STORAGECONFIG_H
#define STORAGECONFIG_H

#include <QString>
#include <QMetaType>

enum {SET_DATAFILE_RAW, SET_DATAFILE_DEV};

class StorageConfig
{
public:
    bool operator==(const StorageConfig &other) const;
    bool operator!=(const StorageConfig &other) const {return !operator==(other);}

    bool enable = false;
    int mode = 0;                //!< 0 = recycle, 1 = continuous
    int period = 10;              //!< timer period in sec
    QString fileName;
    bool enableSizeLimit = false;
    quint64 szlimit = 100*1024*1024;         //!< file size limit
};

Q_DECLARE_METATYPE(StorageConfig)

#endif // STORAGECONFIG_H
