//
//    Copyright 2010-2019 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef ADCCONFIGDIALOG_H
#define ADCCONFIGDIALOG_H

#include "ui_AdcConfigDialog.h"

#include "adcmraw/adcm_mem.h"
#include "config/adcconfig.h"

class QAbstractButton;

class AdcConfigDialog : public QDialog, public Ui::AdcConfigDialog
{
    Q_OBJECT
public:
    explicit AdcConfigDialog(QWidget *parent = nullptr);

Q_SIGNALS:
    void adcConfigChanged(const AdcConfig &r);

public Q_SLOTS:
    void setAdcConfig(const AdcConfig &r);
    void update();

private slots:
    void on_buttonBox_clicked(QAbstractButton* button);
    void on_radioButton_int_simple_toggled(bool checked);
    void on_radioButton_ext_toggled(bool checked);
    void on_radioButton_int_toggled(bool checked);
    void on_spinBox_fragm_len_valueChanged( int base );
    void on_spinBox_fragments_m_valueChanged( int );
    void on_spinBox_fragments_s_valueChanged( int val );
    void on_spinBox_trig_min_valueChanged( int val );
    void on_spinBox_trig_max_valueChanged( int val );
    void on_radioButtonTimestampUTC_toggled( bool );

private:

    conf_mem_t conf_mem;
    AdcConfig adcConfig;
};

#endif // ADCCONFIGDIALOG_H
