/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CHANNELCONTROLWIDGET_H
#define CHANNELCONTROLWIDGET_H

#include <QTableWidget>

class conf_mem_t;
class AdcConfig;
struct adcm_counters_t;

class ChannelControlWidget : public QTableWidget
{
    Q_OBJECT

public:
    explicit ChannelControlWidget(QWidget *parent = nullptr);

Q_SIGNALS:
    void adcConfigChanged(const AdcConfig &);

public Q_SLOTS:
    void setAdcConfMem(const conf_mem_t &r);
    void setAdcConfig(const AdcConfig &r);
    void onHitCountsChanged(const adcm_counters_t &);

private Q_SLOTS:
    void on_cellChanged( int r, int c);
    void gain_changed(int value);

private:
    void init_table_st();
    void update_table_cc_size();
    void update();
    void display_update_channel_controls_visibility();
    void display_refresh_channel_controls();
    void GainRestore();
    void ThrRestore();
    bool desiredCheckedState(int row, int col) const;

    conf_mem_t * const adcConfMem;
    AdcConfig * const adcConfig;
    bool suppressUpdates = false;
};

#endif // CHANNELCONTROLWIDGET_H
