//
//    Copyright 2010-2019 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef RAWSTORAGECONFIGDIALOG_H
#define RAWSTORAGECONFIGDIALOG_H

#include "ui_RawStorageConfigDialog.h"
#include "config/storageconfig.h"

class StorageConfig;

class RawStorageConfigDialog : public QDialog, public Ui::RawStorageConfigDialog
{
    Q_OBJECT
public:
    explicit RawStorageConfigDialog(QWidget *parent = nullptr);

Q_SIGNALS:
    void dataChanged(const StorageConfig &r);

public Q_SLOTS:
    void setData(const StorageConfig &r);

private:
    void update();
    void updateEnableState();

private slots:
    void on_buttonBox_clicked(QAbstractButton* button);
    void on_pushButtonSelect_clicked();
    void on_spinBoxPeriod_valueChanged(int value);
    void on_spinBoxSizeLimit_valueChanged(int value);
    void on_checkBoxSizeLimit_toggled(bool checked);
    void on_checkBoxEnable_toggled(bool checked);
    void on_radioButtonRecycle_clicked();
    void on_radioButtonContinuous_clicked();

private:
    StorageConfig storageConfig;

};

#endif // RAWSTORAGECONFIGDIALOG_H
