//
//    Copyright 2013-2019 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef GENERICDECODER_H
#define GENERICDECODER_H

#include <QObject>

class conf_mem_t;
class AdcConfig;
class DecoderConfig;
class CalZeroConfig;
class CalAvgConfig;

class GenericDecoder: public QObject
{
    Q_OBJECT
public:
    explicit GenericDecoder(QObject *parent = nullptr);
    GenericDecoder(const GenericDecoder &) = delete;
    GenericDecoder &operator=(const GenericDecoder &) = delete;
    ~GenericDecoder() override;

public Q_SLOTS:
    void setAdcConfig(const AdcConfig &_adcConfig);
    void setDecoderConfig(const DecoderConfig &decoderConfig);
//    void setCalZeroConfig(const CalZeroConfig &calZeroConfig);
//    void setCalAvgConfig(const CalAvgConfig &calAvgConfig);

protected:
    AdcConfig * const adc;
    DecoderConfig * const dec;
//    CalZeroConfig * const calZero;
//    CalAvgConfig * const calAvg;
};

#endif // GENERICDECODER_H
