/*
 *
 * ADCM-16 hardware settings and registers definition
 *
 */

#ifndef ADCM16_H
#define ADCM16_H

#include <cstdint>

const unsigned int ADCM_BOARD_NCH = 16;

const unsigned int ADCM_MIN_N_SAMP = 4;
const unsigned int ADCM_MAX_N_SAMP = 4096; /* hardware limit is 8192 */
const unsigned int ADCM_MIN_FRAGM_LEN = ADCM_MIN_N_SAMP;

const unsigned int ADCM_MIN_N_FRAGM = 1;
const unsigned int ADCM_MAX_N_FRAGM = 255;

const unsigned int ADCM_N_CH = 64; /* maximum number of channels in system */
const unsigned int ADC_NCH = ADCM_N_CH; // alias

//const double ADC_TS_FREQ = 1e8;         /* timestamp counter clock, Hz */

const unsigned int ADC_MAX_GAIN = 4095;
const unsigned int ADC_DEFAULT_GAIN = 700;
const unsigned int ADC_GAIN_0dB = 70;

//const unsigned int ADCM_TRIGBIT_EXT = 0x01; /* hardware */
//const unsigned int ADCM_TRIGBIT_EXT2 = 0x02;
//const unsigned int ADCM_TRIGBIT_EXT3 = 0x04;
//const unsigned int ADCM_TRIGBIT_INT_SIMPLE = 0x0200;
const unsigned int ADCM_TRIGBIT_INT = 0x0800;

typedef union {
    uint16_t all;
    struct {
        unsigned int ext1: 1;
        unsigned int ext2: 1;
        unsigned int ext3: 1;
        unsigned int unused1: 6;
        unsigned int int_simple: 1;
        unsigned int unused2: 1;
        unsigned int coinc_logic: 1;
        unsigned int unused3: 4;
    } bit;
} adcm_trigbit_t;

typedef union {
    uint16_t all;
    struct {
        unsigned int en: 1;
        unsigned int s: 1;
        unsigned int m: 1;
        unsigned int test: 1;
        unsigned int zero: 1;
        unsigned int inv: 1;
        unsigned int unused: 10;
    } bit;
} adcm_channel_flags_t;

#endif /* ADCM16_H */
