//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef QXW_WAVEFORMAVERAGER_H
#define QXW_WAVEFORMAVERAGER_H

#include <map>
#include "qxw/WaveformData.h"

typedef std::map<int, quint64> WaveformCountAll;

class WaveformAverager
{
public:
    void add(const WaveformDataAll &);
    WaveformDataAll get() const;
    void clear();
private:
    WaveformDataAll wd;
    WaveformCountAll count; // index is channel number
};

#endif // QXW_WAVEFORMAVERAGER_H
