//
//    Copyright 2010 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef QXW_WAVEFORMMODEL_H
#define QXW_WAVEFORMMODEL_H

#include "qxw/WaveformData.h"
#include "qxw/WaveformAbstractModel.h"

class WaveformModel: public WaveformAbstractModel
{
    Q_OBJECT
public:
    explicit WaveformModel(QObject *parent = nullptr) : WaveformAbstractModel(parent) {}
    //  void simulate();
    //  void resize(unsigned int n) {wd.resize(n);}
    WaveformData get(int channel) const;
    WaveformDataAll get() const {return wda;}
    void set(const WaveformDataAll&w) {wda = w; emit dataChanged();}
    int size() const {return wda.size();} // number of waveforms

protected:
    WaveformDataAll wda;
};

#endif // QXW_WAVEFORMMODEL_H
