#include "Config.h"

#include <QSettings>

void Config::loadSettings()
{
    QSettings settings;

    bool ok;
    const int cnt = settings.beginReadArray("devices");
    quint64 devSerial;
    quint16 devId;
    for(int arrId=0; arrId<cnt; ++arrId) {
        settings.setArrayIndex(arrId);

        QString hexStr = settings.value("serial").toString();
        quint64 serId = hexStr.toULongLong(&ok, 16);
        if(ok && serId) {
            devSerial = serId;
        } else
            continue;
        hexStr = settings.value("id").toString();
        quint16 id = hexStr.toUShort(&ok, 16);
        if(ok && id){
            devId = id;
        } else
            continue;

        devices.push_back(DeviceIndex(devId, devSerial));
    }
    settings.endArray();


    filePath = settings.value("filePath").toString();
    verifyAfterWrite = settings.value("verifyAfterWrite").toBool();
}

void Config::saveSettings()
{
    QSettings settings;

    settings.setValue("filePath", filePath);
    settings.setValue("verifyAfterWrite", verifyAfterWrite);
    settings.remove("devices");
    int arrId = 0;
    settings.beginWriteArray("devices");
    for(DeviceIndex index : devices) {
        settings.setArrayIndex(arrId);
        settings.setValue("id", QString("0x%1")
                          .arg(index.getDevId(), 2,16,QChar('0')));
        settings.setValue("serial", QString("0x%1")
                          .arg(index.getSerial(),8,16,QChar('0')) );
        ++arrId;
    }
    settings.endArray();
}
