#include "Config.h"

#include <QSettings>

Config::Config():
    devSerial(0)
    , devId(0)
    , enabled(true)
  , isCustom(false)
  , regAddr(0)
  , regWriteVal(0)
{
}

void Config::loadSettings()
{
    QSettings settings;

    int val;
    bool ok;
    QString hexStr = settings.value("serial").toString();
    quint64 serId = hexStr.toULongLong(&ok, 16);
    if(ok && serId){
        devSerial = serId;
    }
    hexStr = settings.value("id").toString();
    quint16 id = hexStr.toUShort(&ok, 16);
    if(ok && id){
        devId = id;
    }

    enabled = settings.value("enabled").toBool();
    isCustom = settings.value("isCustom").toBool();
    val = settings.value("regType").toInt(&ok);
    if(ok)
        regType = static_cast<REG_TYPE>(val);
    val = settings.value("regAddr").toInt(&ok);
    if(ok)
        regAddr = static_cast<quint16>(val);
    quint64 val64 = settings.value("regWriteVal").toULongLong(&ok);
    if(ok)
        regWriteVal = val64;
}

void Config::saveSettings()
{
    QSettings settings;

    settings.setValue("serial", QString("0x%1").arg(devSerial,8,16,QChar('0')) );
    settings.setValue("id", QString("0x%1").arg(devId,2,16,QChar('0')));
    settings.setValue("isCustom", isCustom);
    settings.setValue("regType", regType);
    settings.setValue("regAddr", regAddr);
    settings.setValue("regWriteVal", regWriteVal);
}
