﻿#ifndef EVBCONFIG_H
#define EVBCONFIG_H

#include "daq-config/DaqConfig.h"
#include "mongo/BaseConfig.h"
#include "mongo/RootConfig.h"
#include "pnp-server/PNPMessage.h"
#include <QDialog>

struct ClientConfig
{
    ClientConfig() : enabled(true), id(-1), inputBufSize(0) {}
    ProgramDescription descr;
    bool enabled;
    int id;
    quint64 inputBufSize;
};

enum COMBINER_OUT{COMBINER_FILE=0, COMBINER_TCP=1, COMBINER_IDLE=2};
Q_DECLARE_METATYPE(COMBINER_OUT)

class EvBConfig  : public BaseConfig
{
public:
    EvBConfig(QString program_type_init, QString program_index_init);
    virtual ~EvBConfig();
    void read_config();
    void write_config();
    void reset_to_defaults();

    int getEvNumIndex() const { return startEvNumber%evNumberStep;}
    bool isOutFile() const {return combinerOut==COMBINER_FILE;}
    bool isOutTcp() const {return combinerOut==COMBINER_TCP;}
    bool isOutIdle() const {return combinerOut==COMBINER_IDLE;}
    QString getOutputStr() const;

    QString program_type;
    QString program_index;
    QString configuration_name;
    int run_number;
    QString run_index;

    RootConfig root;
    RootConfig default_root;

    COMBINER_OUT combinerOut;
    bool isRemoteEnabled;
    bool advancedCounters;
    int combinerOutTcpNum;
    quint32 startEvNumber; // EvB index in 2nd level
    quint32 evNumberStep; // number of EvB in 2nd level
    QString storageDir;
    QMap<int, ClientConfig> clients;
    bool timeDistrEn;
    quint64 outputBufSize;
    quint16 monitorPort;
};

#endif // EVBCONFIG_H
