#ifndef EVENTMETAINFO_H
#define EVENTMETAINFO_H

#include <QElapsedTimer>

class EventMetaInfo
{
public:
    EventMetaInfo()
        :
          data1(0),
          dataPos1(0),
          size1(0),
          data2(0),
          size2(0),
          corrupted(0),
          skipData(0),
          evNum(0),
          free(true),
          type(0)
    {
        createTime.invalidate();
    }
    void reset() {
        *this = EventMetaInfo();
        createTime.start();
    }

    char *data1; // Pointer to Event Payload
    int dataPos1; // Pointer to Event Payload
    int size1;
    char *data2; // Second part if data splitted (should be the beginning of ring) dataPos2==0
    int size2;
    int corrupted; // space after this event that was marked as corrupted
    int skipData; // data with Start/Stop Run Records
    quint32 evNum;
    QElapsedTimer createTime;
    bool free;
    int type;
};

#endif // EVENTMETAINFO_H
