#ifndef PARAMS_H
#define PARAMS_H

#include <QtGlobal>

const int EVENT_EXPIRE_TIMEOUT_MS = 8000;
const int EXPECTED_EV_RATE_KHZ = 10;
const int EVENT_RING_SIZE = EVENT_EXPIRE_TIMEOUT_MS*EXPECTED_EV_RATE_KHZ;

const int EVENT_SIZE_MAX = 0x7FFFFFFF/EVENT_RING_SIZE; // in bytes
const int EVENT_SIZE_MIN = 1e2; // in bytes
const int EVENT_SIZE_DEFAULT = qMin(10000, EVENT_SIZE_MAX); // in bytes
const int DATA_RING_SIZE = EVENT_RING_SIZE*EVENT_SIZE_DEFAULT;
const int FILE_WRITER_BUFFER_SIZE = DATA_RING_SIZE;
const int TCP_SERVER_BUFFER_SIZE = FILE_WRITER_BUFFER_SIZE;

const quint64 EV_SIZE_PERIOD_MIN_CNT = 1e3;
const qint64 EV_SIZE_PERIOD_MS = 1e4;
#endif // PARAMS_H
