#ifndef DEVICECONFIG_H
#define DEVICECONFIG_H

#include "mldiscover/DeviceIndex.h"
#include "mongo/RootConfig.h"

class DeviceConfig
{
public:
    const static int N_CH = 16;
    DeviceConfig();
    void root_to_values(RootConfig root);
    RootConfig values_to_root();

    DeviceIndex device_index;
    double trashed_all;
    QMap<int, double> channel_thr_map;
    QVector<double> baseLine;
    bool enabled;
    QString lut_path;
    int hit_extension;

private:
    void init_default_config();
};
Q_DECLARE_METATYPE(DeviceConfig)

#endif // DEVICECONFIG_H
