//
//    Copyright 2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef SPILLCONFIG_H
#define SPILLCONFIG_H

#include <QtGlobal>
#include <mongo/RootConfig.h>

class QDebug;
class QSettings;

class SpillConfig
{
public:
    typedef enum {SPILL_OFF=0, SPILL_TIMER=1, SPILL_TTL=2, SPILL_WR=3, SPILL_AUTO=7, SPILL_GATE=8} spill_sel_t;
    SpillConfig();
    bool operator==(const SpillConfig &ref) const;
    bool root_to_variables(RootConfig root);
    RootConfig variables_to_root();

    quint32 durPhase1; // acceleration, ms
    quint32 durPhase2; // prep, ms
    quint32 durPhase3; // readout, ms
    quint32 durPhase4; // post-readout, ms
    quint32 durPhase5; // flush, ms
    spill_sel_t source;
//    bool modeAuto;
    bool softSpill;
    quint32 timerPeriod; // in ms
    quint32 spillPlotStep; // in clocks
    quint32 trigTimeStep; // in clocks
};

QDebug operator <<(QDebug stream, const SpillConfig &spill);


#endif // SPILLCONFIG_H
