#include "TrigChannelState.h"

double TrigChannelState::xOffTimeRelative(int ch) const
{
    return (globalXoffTime > 0) ? (1.*xOffTime[ch]/globalXoffTime) : 0.;
}

double TrigChannelState::globalXOffTimePerEvent() const
{
    if (globalEventCount == 0)
        return 0;
    return globalXoffTime / globalEventCount;
}

double TrigChannelState::xOffTimePerEvent(int ch) const
{
    if (eventCount[ch] == 0)
        return 0;
    return xOffTime[ch] / eventCount[ch];
}
