#ifndef TRIGCHANNELSTATE_H
#define TRIGCHANNELSTATE_H

#include <QMap>
#include <QString>
#include <QMetaType>

class TrigChannelState
{
public:
    TrigChannelState() : nch(0), globalEventCount(0), xOff(0), timeout(0), globalXoffTime(0) {}
    double xOffTimeRelative(int ch) const;
    double globalXOffTimePerEvent() const;
    double xOffTimePerEvent(int ch) const;

    int nch;
    quint64 globalEventCount;
    quint16 xOff;
    quint16 timeout;
    double globalXoffTime;
    QMap<int, quint64> eventCount;
    QMap<int, double> xOffTime;
    QMap<int, QString> xOffTimeStr;
    QMap<int, quint64> timeoutXoff;
    QMap<int, quint64> timeoutRead;
};

Q_DECLARE_METATYPE(TrigChannelState)

#endif // TRIGCHANNELSTATE_H
