//
//    Copyright 2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef TRIGCONFIG_H
#define TRIGCONFIG_H

#include <QtGlobal>
#include <mongo/RootConfig.h>

class QDebug;
class QSettings;

class TrigConfig
{
public:
    enum {TrigMaskTimer = 0x8000, TrigMaskRandom = 0x4000, TrigMaskLvds = 0x2000};
    TrigConfig();
    bool operator==(const TrigConfig &ref) const;
    bool root_to_variables(RootConfig root);
    RootConfig variables_to_root();

    quint16 xOffMask;
    bool trigOpen;
    quint16 trigSrc;
    double trigTimerFreq;  // Hz
    double trigRandomFreq; // Hz
    double trigRandomDeadTimeUs; // us
};

QDebug operator <<(QDebug stream, const TrigConfig &trig);

#endif // TRIGCONFIG_H
