#ifndef CONFIG_H
#define CONFIG_H
#include "mongo/BaseConfig.h"
#include "CalConfig.h"
#include "file-reader-dialog/FileReaderDialog.h"
#include "TDC2ViewerStartupOptions.h"

#include <QMetaType>
#include <QString>

enum SOURCE_DATA {SOURCE_IDLE=0, SOURCE_STREAM=1, SOURCE_FILE=2};
struct InvertMapType : public QMap<DeviceIndex, QMap<int, bool> > {};
Q_DECLARE_METATYPE(InvertMapType);
struct TdcTtvxsMapType : public QMap<DeviceIndex, DeviceIndex> {};
Q_DECLARE_METATYPE(TdcTtvxsMapType);

class Config : public CalConfig, public BaseConfig
{
public:
    Config(TDC2ViewerStartupOptions &startup_options);
    ~Config();
    bool read_config();
    void update_root();
    bool write_config();

    DeviceCalibration &getCalibration(const DeviceIndex &index);
    DeviceCalibration &getCurrentCalibration();
    virtual void reloadCalibration();

public:
    RootConfig root;
    RootConfig default_root;
    QString program_type;
    QString program_version;
    QString program_index;
    QString configuration_name;
    bool debug_mode;

    QString sourse_program_type;
    QString sourse_program_index;
    bool rawDataEveryEv;
    int rawDataLimit;
    bool rawDataPeriodic;
    int rawDataPeriod;
    QString progInterfaceType;
    bool useSeparateInl;
    QString separateInlFolder;

    SOURCE_DATA source;
    InvertMapType invertMap;
    FileReaderConfig file_reader_config;
    TdcTtvxsMapType tdc_ttvxs_map;
};

#endif // CONFIG_H


