#ifndef ADJUSTDIALOG_H
#define ADJUSTDIALOG_H

#include <QDialog>

#include "DeviceSetup.h"

namespace Ui {
class AdjustDialog;
}


class AdjustDialog : public QDialog
{
    Q_OBJECT
public:
    explicit AdjustDialog(QWidget *parent = nullptr);
    ~AdjustDialog();
    void setConfig(Adjust_setup s);

signals:
    void adjust_setup_changed(Adjust_setup);

public slots:
    void activate_dialog();

private slots:
    void on_comboBox_readout_fifo_currentIndexChanged(int index);
    void on_checkBox_rc_compression_clicked(bool checked);
    void on_comboBox_lr_currentIndexChanged(int index);
    void on_checkBox_pairing_mode_clicked(bool checked);
    void on_comboBox_dll_mode_currentIndexChanged(int index);
    void on_comboBox_dll_clock_currentIndexChanged(int index);
    void on_comboBox_core_clock_source_currentIndexChanged(int index);
    void on_pushButton_OK_clicked();

private:
    void write_setup();

    Ui::AdjustDialog *ui;
    Adjust_setup adjust_set;
    bool block_write;
};

#endif // ADJUSTDIALOG_H
