#include "MainWindow.h"
#include "TQDC2StratupOptions.h"
#include "mongo/BaseConfig.h"

#include <QApplication>
#include <QStyleFactory>
#include <QCommandLineParser>

const QString PROGRAM_TYPE = "TQDC2";
int main(int argc, char *argv[])
{
    QCoreApplication::setOrganizationName("AFI Electronics");
    QCoreApplication::setOrganizationDomain("local");
    QCoreApplication::setApplicationName("AFI-TQDC2");

    QApplication a(argc, argv);
    if(QStyleFactory::keys().contains("Fusion")) {
        a.setStyle(QStyleFactory::create("Fusion"));
    } else
        if(QStyleFactory::keys().contains("Plastique")) {
            a.setStyle(QStyleFactory::create("Plastique"));
        } else
            if(QStyleFactory::keys().contains("Windows")) {
                a.setStyle(QStyleFactory::create("Windows"));
            }

    #ifdef MONGO_DRIVERS
        mongocxx::instance insta{};
    #endif
    BaseConfig base_config;
    base_config.init(PROGRAM_TYPE);

    TQDC2StartupOptions startup_options(PROGRAM_TYPE);
    startup_options.parse_options();

    MainWindow w(startup_options);
    w.show();

    return a.exec();
}

//--- garbage
//    QCommandLineParser parser;
//    parser.setApplicationDescription(a.applicationName().append(" helper"));
//    parser.addHelpOption();

//    // A boolean option with multiple names (-I, --inl)
//    QCommandLineOption inlOption(QStringList() << "I" << "inl",
//                                 QCoreApplication::translate("main", "Enables save INL correction"));
//    parser.addOption(inlOption);

//    // Process the actual command line arguments given by the user
//    parser.process(a);

//    bool inlEnabled = parser.isSet(inlOption);
