#ifndef CONFIG_H
#define CONFIG_H

#include "TtvxsConfig.h"
#include "mldiscover/DeviceIndex.h"
#include "mongo/BaseConfig.h"
#include "mongo/RootConfig.h"
#include "run-control-client-manager/ClientConfig.h"

class StartupOptions;

class Config : public BaseConfig
{
public:
    Config(const StartupOptions &startupOptions);
    void read_config();
    void write_config();
    void unify_config();
    static RootConfig get_root_config(const TtvxsConfig &devCfg);
    static TtvxsConfig get_device_config(const RootConfig &devCfg);

    QMap<DeviceIndex, TtvxsConfig> devicesCfg;
    TtvxsConfig default_cfg;

    QString program_type;
    QString program_index;
    QString configuration_name;

    bool debug_mode;
    bool runEnable;
    QString run_index;
    int run_number;
    int localRunNumber;
    bool allowRemoteControl;

    QMap<int, ClientConfig> clients;

    RootConfig root;
    RootConfig default_root;

private:
    void update_root();
};

#endif // CONFIG_H
