#include "PrintInfo.h"
#include <QStringList>
#include "iostream"

void print(QString s, bool noLog)
{
#ifdef _WIN32
    std::cerr<<s.toStdString();
#else
#if QT_VERSION < QT_VERSION_CHECK(5, 5, 0)
    qDebug()<<s;
#else
    if(noLog)
        std::cerr<<s.toStdString();
    else
        qInfo()<<s;
#endif // QT_VERSION
#endif // _WIN32
}

QString humanReadableSize(double size)
{
    QStringList list;
    list << "KB" << "MB" << "GB" << "TB";

    QStringListIterator i(list);
    QString unit("bytes");

    while(size >= 1024.0 && i.hasNext())
    {
        unit = i.next();
        size /= 1024.0;
    }
    return QString().setNum(size,'f',2)+" "+unit;
}
 
