#ifndef MLDPLISTENER_H
#define MLDPLISTENER_H

#include <QObject>
#include <QMetaType>

class QHostAddress;

class MultiCastListener;
#include "DeviceDescription.h"

class MldpListener : public QObject
{
    Q_OBJECT
public:
    explicit MldpListener(QObject *parent = nullptr);
    explicit MldpListener(const QHostAddress &_host, quint16 _port, QObject *parent = nullptr);

signals:
    void received(const DeviceDescription &) const;

private slots:
    void analyzeData(const QByteArray &data, const QHostAddress &host) const;
    static DeviceDescription decodeData(const QByteArray &data, const QHostAddress &host, bool *ok = nullptr);

protected:
    void timerEvent(QTimerEvent *event);

private:
    MultiCastListener * const rawListener;
};

#endif // MLDPLISTENER_H
