#ifndef MSTREAMOUTPUT_H
#define MSTREAMOUTPUT_H

#include <QMetaType>
#include <QWidget>

#include "mldiscover/DeviceIndex.h"

namespace Ui {
class MStreamOutput;
}
struct MStreamStatus {
    void clear() { recv_speed.clear(); bad_format.clear(); }
    QString recv_speed;
    QString bad_format;
};
Q_DECLARE_METATYPE(MStreamStatus)

class MStreamOutput : public QWidget
{
    Q_OBJECT

public:
    explicit MStreamOutput(QWidget *parent = nullptr);
    ~MStreamOutput();

signals:
    void mstream_stat_updated(QString serial, MStreamStatus);

public slots:
    void mstream_table_output(QString serial, QString out_str_full);
    void add_device(QString serial);
    void remove_device(QString serial);
    void mstream_log_output(QString serial, QString str);

private slots:
    void on_checkBox_table_toggled(bool checked);
    void on_checkBox_log_toggled(bool checked);

private:
    int get_column_by_serial(QString serial);
    int get_mstream_row(const QString &tag);
    void check_for_tag_dublicate(QString line, QString full_text);
    void update_error_status(QString serial);

    Ui::MStreamOutput * ui;
    QVector<QString> mstream_tags;
    QMap<QString, QString> dumper_tags;
    QMap<QString, QString> reciever_tags;
    QMap<QString, MStreamStatus> status;
    QMap<QString, QMap<QString, bool> > error_status;
    bool ms_tag_dublicate;
};

#endif // MSTREAMOUTPUT_H
