#ifndef STATISTICOUTPUT_H
#define STATISTICOUTPUT_H

#include <QWidget>
#include "mstream-lib/MStreamDump.h"

namespace Ui {
class StatisticOutput;
}

class StatisticOutput : public QWidget
{
    Q_OBJECT

public:
    explicit StatisticOutput(QWidget *parent = nullptr);
    ~StatisticOutput();
    void add_device(DeviceIndex index);
    void remove_device(DeviceIndex index);
    void remove_all_devices();
    QMap<DeviceIndex, MStreamStat> getStat() const { return prev_ms_stat; }

public slots:
    void stat_updated(const MStreamStat &ms_stat);
    void stat_from_receiver_updated(ReceiverStat stat);
    void on_checkBox_toggled(bool checked);
    void set_run_state(bool run);

private:
    void init_table();
    int index_to_row(DeviceIndex index) const;
    DeviceIndex row_to_index(int row) const;
    void update_column_visible() const;
    void set_table_text(int row, int col, quint64 val);
    void set_table_text(int row, int col, quint32 val);
    void set_table_text(int row, int col, double val);

    Ui::StatisticOutput *ui;
    QSet<DeviceIndex> devices;
    QMap<DeviceIndex, MStreamStat> prev_ms_stat;

    bool show_all;
    bool run;
};

#endif // STATISTICOUTPUT_H
