#ifndef CLIENTCONFIG_H
#define CLIENTCONFIG_H

#include <QString>

#include "daq-config/DaqConfig.h"
#include <QMetaType>

enum CLIENT_PROTO_ID {
    CLIENT_PROTO_UNKNOWN=0,
    CLIENT_PROTO_V1=1, // simple string
    CLIENT_PROTO_V2=2, // RC_MSG_CMD_OLD
    CLIENT_PROTO_V3=3, // RC_MSG_CMD
};
Q_DECLARE_METATYPE(CLIENT_PROTO_ID)

struct ClientConfig {
    ClientConfig() :
        id(-1)
      , readout(true)
      , evNumCheck(false)
      , has_vme(false)
      , protoId(CLIENT_PROTO_UNKNOWN)
    {}

    bool hasVme() const {
        return has_vme || program_type == DaqConfig::getTypeName(DaqConfigVmeDaq);
    }

    int id;
    QString program_type;
    QString program_index;
    bool readout;
    bool evNumCheck;
    bool has_vme;
    CLIENT_PROTO_ID protoId;
};

#endif // CLIENTCONFIG_H
