/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MLINKDEVICEINTERFACEDUMP_H
#define MLINKDEVICEINTERFACEDUMP_H

#include "MlinkDeviceInterfaceBase.h"

#include <cstdio>
namespace mlink {
class MlinkDeviceInterfaceDump : public MlinkDeviceInterfaceBase
{
public:
    int ml_open(const char *devname) override;
    int ml_close() override;
    int ml_dma_read (uint32_t buf[], size_t nwords, size_t * words_received, int timeout) override;
    int ml_dma_write (const uint32_t buf[], size_t nwords, int timeout) override;
private:
    FILE *ml_rx_dump_file = nullptr;
    FILE *ml_tx_dump_file = nullptr;
};
}

#endif // MLINKDEVICEINTERFACEDUMP_H
