/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include "frame_hw_debug.h"

#include <QString>
#include <QDebug>

#include "mlink/mlink_frame_header.h"

QTextStream &operator<<(QTextStream &stream, const frame_hdr_t &fh)
{
    stream << QString("Frame header: sync %1, type %2, len %3, seq %4, src %5, dst %6")
                  .arg(fh.sync, 4, 16, QChar('0'))
                  .arg(fh.type, 4, 16, QChar('0'))
                  .arg(fh.len, 4, 16, QChar('0'))
                  .arg(fh.seq, 4, 16, QChar('0'))
                  .arg(fh.src, 4, 16, QChar('0'))
                  .arg(fh.dst, 4, 16, QChar('0'))
        ;
    return stream;
}

QDebug &operator<<(QDebug &stream, const frame_hdr_t &fh)
{
    QString str;
    QTextStream ts(&str);
    ts << fh;
    stream << str;
    return stream;
}
