/*
**    Copyright 2019 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef FRAMESET_H
#define FRAMESET_H

#include <cstddef>
#include <cstdint>

namespace mlink {

enum { ML_FRAMESET_NUMDESC = 1024 }; // 16kByte max rawdata, min frame size 16 bytes // FIXME

typedef struct framedesc_t {
    const uint32_t *rawdata = nullptr;
    size_t len = 0;
    int frame_flags = 0;
} framedesc_t;

typedef struct frameset_t {
    //  size_t maxdesc; // number of descriptors allocated
    size_t count = 0; // number of descriptors used
    framedesc_t fdesc[ML_FRAMESET_NUMDESC];
} frameset_t;

} // namespace mlink

#endif // FRAMESET_H
