
#include "LinkStats.h"

#include <QDebug>

#include "mlink/mlink_frame_header.h"

void LinkStats::print() const
{
    qDebug() << QString("RX Stats: pkt_count: %1, f110: %2, f112: %3, fxxx: %4, bytes: %5")
        .arg(rx_pkt_count)
        .arg(rx_frame_count_110)
        .arg(rx_frame_count_112)
        .arg(rx_frame_count_other)
        .arg(rx_byte_count);
}

void LinkStats::clear()
{
    *this = LinkStats();
}

void LinkStats::countPacket(int type, size_t datawords)
{
    if (type == 0x0110) rx_frame_count_110++;
    else
        if (type == 0x0112) rx_frame_count_112++;
    else
        rx_frame_count_other++;
    rx_pkt_count++;
    rx_byte_count += 4*(datawords + ML_FRAME_HEADER_WORDS+ML_FRAME_TRAILER_WORDS);
}
