//
//    Copyright 2015 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include "WrEpStatus.h"
#include <cstdlib>

/// Check time is in sync with local time, ntpd should be running.
int WrEpStatus::wrTimeCheck() const
{
    auto wrTimeOffsetMs = mSecsSinceEpoch() - acquiredAtMs;
    if (acquireErrorMs < 5) {
        int wrTimeErrorMs = std::abs((int)(wrTimeOffsetMs + 500) % 1000 - 500); // milliseconds part
        // no check for seconds (offset changes every time leap second is added)
        if (wrTimeErrorMs > 50)
            return 2;
        if (wrTimeErrorMs > 10)
            return 1;
    }
    return 0;
}
