#ifndef MLINK_REGIOMLINK_H
#define MLINK_REGIOMLINK_H

/*
 * Register-based I/O
 */

#include <cstddef>
#include <string>
#include <vector>
#include <list>

#include <QHostAddress>

#include <regio/regiobase.h>

class QUdpSocket;
class QByteArray;

namespace mlink {

const int MlinkHostAddress = 1;

class RegIOMLink: public RegIOBase
{
    Q_OBJECT

public:
    RegIOMLink(QObject *parent, const QHostAddress &address = QHostAddress()); //<! Construct M-Link Register I/O object with specified device address
    ~RegIOMLink() override;
    //  static std::string defaultDevName();
    void reset() override;
    void rawSend(const RegIoPacket &data) override; //< \deprecated
    unsigned long getMaxDataSize() const override;

protected:
     double getDeviceThroughput() const override;
    //  virtual PacketList getRxPackets(double timeout); //<! get packets from hardware
    void processPacket(const QByteArray &buf);
     bool updateRxBuf(double timeoutMs) override;

    std::vector<int> rawRxBuf;
    QUdpSocket * const socket;

private Q_SLOTS:
    void readSocketData();
};

} // namespace mlink

#endif /* MLINK_REGIOMLINK_H */
