//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef MULTIDOUBLESPINBOX_H
#define MULTIDOUBLESPINBOX_H

#include <QVector>
#include <QWidget>
#include <QVector>
#include <qxw/qxw_global.h>

namespace Ui {
    class MultiDoubleSpinBox;
}

class QCheckBox;
class QDoubleSpinBox;

class QXW_EXPORT MultiDoubleSpinBox : public QWidget
{
    Q_OBJECT

public:
    MultiDoubleSpinBox(QWidget *parent = 0);
    ~MultiDoubleSpinBox();
    void setSuffix ( const QString & suffix );
    virtual void setValues(const QVector<double> &data, const QVector<int> &states);
    void setRange ( double minimum, double maximum );
    virtual QVector<double> getValues() const;
    virtual QVector<int> getStates() const;

protected:
    void changeEvent(QEvent *e);

private:
    int numInputs() const;
    Ui::MultiDoubleSpinBox *ui;
    QVector<QCheckBox*> pointCheckBoxes;
    QVector<QDoubleSpinBox*> pointSpinBoxes;

};

#endif
