//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef WAVEFORMVIEWFORM_H
#define WAVEFORMVIEWFORM_H

#include <QWidget>
#include "qwt_plot_marker.h"

#include <qxw/qxw_global.h>
#include <qxw/WaveformViewSetup.h>
#include <qxw/WaveformData.h>
#include <qxw/WaveformModel.h>

namespace Ui {
    class WaveformView;
}

class WaveformPlot;

class QXW_EXPORT WaveformView : public QWidget
{
    Q_OBJECT
public:
    WaveformView(QWidget *parent = 0);
    ~WaveformView();
    WaveformPlot *getPlot();
    void setGain( int d );
    void setAutoscale( bool b );
    void setOffset( int d );
    void clear();
    void setWaveformData( const WaveformDataAll &w );
    void setCurrentTimeMarker(double v);
    void setXMarkers(const std::vector<double> &v);

protected:
    void changeEvent(QEvent *e);
    void init();

private:
    Ui::WaveformView *ui;
    WaveformViewSetup setup;
    WaveformModel wfm;
    QwtPlotMarker currentTimeMarker;

};

#endif // WAVEFORMVIEWFORM_H
